Description

When creating a Smart Class Parameter, I am able to over ride the default value, set type to yaml and input validated yaml into the

default value box.

If I then add a matcher-value combination of hostgroup = engineering and try to override with yaml it fails to save. I am however able

to set the value to a simple value (ie: string). There are no errors reported in the foreman log.

I am running version 1.1stable on CentOS v6.

Related issues:

Related to Foreman - Bug #3889: No validation errors for nested class paramet... Closed 12/16/2013

Associated revisions

Revision cfc2bb66 - 02/07/2014 09:17 AM - Stephen Benjamin

fixes #2726 - smart class parameter override fails validation

Revision ddfc6c4f - 02/14/2014 12:13 PM - Stephen Benjamin

fixes #2726 - smart class parameter override fails validation

(cherry picked from commit cfc2bb662f49d8216c2388ab35dd87af295474d0)

History

#1 - 07/05/2013 06:44 AM - Luke Kreczko

Same problem here with foreman 1.2 (latest) on Scientific Linux 6.4. It is possible to save the document if specifying 'hash' instead of 'yaml' (and

'string' would work as well I guess).

#2 - 07/12/2013 01:36 AM - Matthew Ceroni

Luke Kreczko wrote:

Same problem here with foreman 1.2 (latest) on Scientific Linux 6.4. It is possible to save the document if specifying 'hash' instead of 'yaml' (and

'string' would work as well I guess).

 Are you able to specify complex data structures using string or hash? I was using yaml to define an array with embedded hashes, which in turn

contain arrays.

As an example I had the following in JSON:

{"pam_files":["system-auth-ac","password-auth-ac"],"access_control_list":[{"comment":"User root should be allowed to get access via cron .. tty5

tty6","permission":"+","name":"root","origins":["cron","crond",":0","tty1","tty2","tty3","tty4","tty5","tty6"]}]}

Not being able to over-ride is kind of a big issue for me right now. This above data structure is used in a module that configures the

/etc/security/access.conf file. I was trying to over-ride it based on the hostgroup (each hostgroup represents a specific department).

#3 - 07/15/2013 12:11 PM - Tim Robinson

Same issue here with YAML working when input as an override from the host paramaters screen but not saving when using 'Add Matcher-Value' in
class config.  Foreman 1.1

#4 - 08/02/2013 01:27 PM - Andy Bohne

+1

Foreman 1.2 on RHEL 6 here.

#5 - 08/05/2013 04:10 AM - Dominic Cleal

- Description updated

- Target version set to 1.3.0

#6 - 09/16/2013 12:13 PM - Lukas Zapletal

- Target version deleted (1.3.0)

#7 - 11/07/2013 07:44 PM - Jason Ashby

This bug is still open, right?  I had this issue on 1.2.2 and now also 1.3.0 with yaml and hashes, whether nested or just one level deep.  Right now I'm

using heira as a "workaround", but would prefer to have my data all in Foreman.

#8 - 11/08/2013 03:35 PM - Jason Ashby

Actually, looks like I was entering hashes incorrectly. I was using JSON format, but it seems Foreman expects a hash as yaml, e.g.:

node: 

  network: 

    host: 127.0.0.1

  index: 

    number_of_shards: 5

    number_of_replicas: 0

  path:

    data: /usr/local/elasticsearch/data

 This sounds different than the problem described in this issue.

An error message would be helpful when submitting changes to class parameters if they fail. Currently, it just redirects to the same edit page with no

message.  FYI when I set log_level to debug, I see this in the logs:

#<OrderedHash {:"class_params.default_value"=>["is invalid"]}>

#9 - 12/16/2013 04:11 PM - Andy Bohne

Jason Ashby wrote:

An error message would be helpful when submitting changes to class parameters if they fail. Currently, it just redirects to the same edit page

with no message.

 This is probably my biggest aggravation with foreman.  An error message in the UI would be invaluable in helping to determine what the issue is.

#10 - 12/16/2013 06:21 PM - Dominic Cleal

- Related to Bug #3889: No validation errors for nested class parameters on Puppet class edit page added

#11 - 12/16/2013 06:26 PM - Dominic Cleal

I've sent a patch in the related issue #3889, if you get the chance to try it.  I haven't tried reproducing this YAML issue yet, but at least that small patch

should cause validation errors to be displayed in the UI.

#12 - 01/29/2014 01:46 PM - Peter Gustafsson

Hi, I'm hitting the same issue in foreman 1.3.2:

i can add below yaml to override default value, but when i'm trying to add the yaml as an hostgroup match it fails to save.

test1:

network_address: 192.168.122.0

netmask: 255.255.255.0

gateway: 192.168.122.1

test2:

network_address: 192.168.123.0

netmask: 255.255.255.0

gateway: 192.168.122.1
https://projects.theforeman.org/issues/3889


Br, Peter

#13 - 02/06/2014 02:36 PM - Stephen Benjamin

- Assignee set to Stephen Benjamin

- Target version set to 1.9.1

PR: https://github.com/theforeman/foreman/pull/1219

#14 - 02/06/2014 02:38 PM - Dominic Cleal

- Category set to Parameters

- Status changed from New to Ready For Testing

#15 - 02/07/2014 09:16 AM - Dominic Cleal

- translation missing: en.field_release set to 5

#16 - 02/07/2014 09:31 AM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset cfc2bb662f49d8216c2388ab35dd87af295474d0.

Powered by TCPDF (www.tcpdf.org)

05/17/2024 3/3

https://github.com/theforeman/foreman/pull/1219
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/cfc2bb662f49d8216c2388ab35dd87af295474d0
http://www.tcpdf.org

